/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.EntCosmos;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author obper
 */
@Entity
@Table(name = "detalle_oferta")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "DetalleOferta.findAll", query = "SELECT d FROM DetalleOferta d"),
        @NamedQuery(name = "DetalleOferta.findByOfertaCodigo", query = "SELECT d FROM DetalleOferta d WHERE d.detalleOfertaPK.ofertaCodigo = :ofertaCodigo"),
        @NamedQuery(name = "DetalleOferta.findByProductoCodigo", query = "SELECT d FROM DetalleOferta d WHERE d.detalleOfertaPK.productoCodigo = :productoCodigo"),
        @NamedQuery(name = "DetalleOferta.findByOfertaCantidad", query = "SELECT d FROM DetalleOferta d WHERE d.ofertaCantidad = :ofertaCantidad"),
        @NamedQuery(name = "DetalleOferta.findByOfertaPromocional", query = "SELECT d FROM DetalleOferta d WHERE d.ofertaPromocional = :ofertaPromocional")})
public class DetalleOferta implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected DetalleOfertaPK detalleOfertaPK;
    @Basic(optional = false)
    @NotNull
    @Column(name = "oferta_cantidad")
    private short ofertaCantidad;
    @Basic(optional = false)
    @NotNull
    @Column(name = "oferta_promocional")
    private boolean ofertaPromocional;
    @JoinColumn(name = "oferta_codigo", referencedColumnName = "oferta_codigo", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Ofertas ofertas;

    public DetalleOferta() {
    }

    public DetalleOferta(DetalleOfertaPK detalleOfertaPK) {
        this.detalleOfertaPK = detalleOfertaPK;
    }

    public DetalleOferta(DetalleOfertaPK detalleOfertaPK, short ofertaCantidad, boolean ofertaPromocional) {
        this.detalleOfertaPK = detalleOfertaPK;
        this.ofertaCantidad = ofertaCantidad;
        this.ofertaPromocional = ofertaPromocional;
    }

    public DetalleOferta(String ofertaCodigo, String productoCodigo) {
        this.detalleOfertaPK = new DetalleOfertaPK(ofertaCodigo, productoCodigo);
    }

    public DetalleOfertaPK getDetalleOfertaPK() {
        return detalleOfertaPK;
    }

    public void setDetalleOfertaPK(DetalleOfertaPK detalleOfertaPK) {
        this.detalleOfertaPK = detalleOfertaPK;
    }

    public short getOfertaCantidad() {
        return ofertaCantidad;
    }

    public void setOfertaCantidad(short ofertaCantidad) {
        this.ofertaCantidad = ofertaCantidad;
    }

    public boolean getOfertaPromocional() {
        return ofertaPromocional;
    }

    public void setOfertaPromocional(boolean ofertaPromocional) {
        this.ofertaPromocional = ofertaPromocional;
    }

    public Ofertas getOfertas() {
        return ofertas;
    }

    public void setOfertas(Ofertas ofertas) {
        this.ofertas = ofertas;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (detalleOfertaPK != null ? detalleOfertaPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DetalleOferta)) {
            return false;
        }
        DetalleOferta other = (DetalleOferta) object;
        if ((this.detalleOfertaPK == null && other.detalleOfertaPK != null) || (this.detalleOfertaPK != null && !this.detalleOfertaPK.equals(other.detalleOfertaPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "dbCon.DetalleOferta[ detalleOfertaPK=" + detalleOfertaPK + " ]";
    }

}
